<?php
/**
 * @author       Aicha Vack
 * @package      Joomla.Site
 * @subpackage   com_visforms
 * @link         https://www.vi-solutions.de
 * @license      GNU General Public License version 2 or later; see license.txt
 * @copyright    2018 vi-solutions
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\HTML\HTMLHelper;

if (!empty($displayData) && isset($displayData['recordId']) && isset($displayData['detailTemplates']) && isset($displayData['pdfTemplates']) && isset($displayData['form'])) {
    $recordId = $displayData['recordId'];
    $detailTemplates = $displayData['detailTemplates'];
    $pdfTemplates = $displayData['pdfTemplates'];
    $form = $displayData['form'];
    $options = array();
    foreach ($detailTemplates as $id => $display) {
        // display is an array with a list of all items for which the user can download this pdf (so it may be empty)
        if ($display && in_array($recordId, $display)) {
            $pdfDownloadlinkText = (!empty($text = \VisformsHelper::getPdfDownlaodLinkTitle($id, $pdfTemplates))) ? Text::sprintf('COM_VISFORMS_DOWNLOAD_AS_PDF_TEXT_FOR_NAMED_DOCUMENT', $text) : Text::_('COM_VISFORMS_DOWNLOAD_PDF');
            $options[] = '<option value="renderPdf_' . $id . '">' . $pdfDownloadlinkText . '</option>';
        }
    }
    if (!empty($options)) {
        HTMLHelper::_('visforms.addListTaskScript');
        $emptyOption = '<option value="" selected="selected">' . Text::_('COM_VISFORMS_SELECT_LIST_DOWNLOAD_DOCUMENT') . '</option>';
        $options = implode('', $options);
        $label = '<label id="select-list-pdf-download-lbl" for="select-list-pdf-download" class="visually-hidden sr-only uk-invisible">' . Text::_('COM_VISFORMS_SELECT_LIST_DOWNLOAD_DOCUMENT_LABEL') . '</label>';
        $list = $label . '<select id="select-list-pdf-download" name="select-list-pdf-download" class="form-select" onchange="return vflistTask(this)" style="display: inline-block; width: auto; vertical-align: middle" data-form-id="'.$form->id.'">' . $emptyOption . $options . '</select>';
        echo $list;
    }
}