<?php
/**
 * @author       Aicha Vack
 * @package      Joomla.Site
 * @subpackage   com_visforms
 * @link         https://www.vi-solutions.de
 * @license      GNU General Public License version 2 or later; see license.txt
 * @copyright    2018 vi-solutions
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\HTML\HTMLHelper;

if (!empty($displayData) && isset($displayData['form']) && isset($displayData['user']) && isset($displayData['pdfTemplates'])) {
    $form = $displayData['form'];
    $user = $displayData['user'];
    $pdfTemplates = $displayData['pdfTemplates'];
    $options = array();
    if ((!empty($form->displaypdfexportbutton_list) && !empty($form->listPdfTemplate))) {
        foreach ($form->listPdfTemplate as $listPdfTmplId) {
            // check user has permission to create a pdf of this template
            if ($user->authorise('core.create.pdf', 'com_visforms.visform.' . (int)$form->id . '.vispdf.' . (int) $listPdfTmplId) || $user->authorise('core.create.own.pdf', 'com_visforms.visform.' . (int)$form->id . '.vispdf.' . (int) $listPdfTmplId)) {
                $pdfDownloadlinkText = (!empty($text = \VisformsHelper::getPdfDownlaodLinkTitle($listPdfTmplId, $pdfTemplates))) ? Text::sprintf('COM_VISFORMS_DOWNLOAD_AS_PDF_TEXT_FOR_NAMED_DOCUMENT', $text) : Text::_('COM_VISFORMS_DOWNLOAD_PDF');
                $options[] = '<option value="renderPdfList_'.$listPdfTmplId.'">' . $pdfDownloadlinkText . '</option>';
            }
        }
        if (!empty($displayData['addCsv'])) {
            $options[] = '<option value="exportCsv">' . Text::_('COM_VISFORMS_EXPORT_TO_CSV') . '</option>';
        }
        if (!empty($options)) {
            HTMLHelper::_('visforms.addListTaskScript');
            $emptyOption = '<option value="" selected="selected">' . Text::_('COM_VISFORMS_SELECT_LIST_DOWNLOAD_DOCUMENT') . '</option>';
            $options = implode('', $options);
            $label = '<label id="select-list-pdf-download-lbl" for="select-list-pdf-download" class="visually-hidden sr-only uk-invisible">'.Text::_('COM_VISFORMS_SELECT_LIST_DOWNLOAD_DOCUMENT_LABEL').'</label>';
            $list = $label . '<select id="select-list-pdf-download" name="select-list-pdf-download" class="form-select" onchange="return vflistTask(this)" data-form-id="'.$form->id.'">'.  $emptyOption. $options . '</select>';
            echo $list;
        }
    }
}